<script lang="ts">
import Vue from 'vue';
import { MrktoForm } from '~/components/common/index.vue';

export default Vue.extend({
  components: {
    MrktoForm,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
});
</script>

<template>
  <div class="form-container" :class="`form-container--${data.theme}`">
    <SlpIcon
      :name="data.icon?.name ?? 'docs'"
      :variant="data.icon?.variant ?? 'marketing'"
      :alt="data.icon?.alt ?? 'docs icon'"
      size="lg"
      hex-color="#A989F5"
    />
    <SlpTypography class="header" variant="heading2-bold" tag="h2">
      {{ data.header }}
    </SlpTypography>
    <SlpTypography class="description" variant="body1" tag="p">
      {{ data.description }}
    </SlpTypography>
    <MrktoForm class="slp-pt-md-24" :data="data.form" />
  </div>
</template>

<style lang="scss" scoped>
.form-container {
  color: $color-surface-800;
  margin: -$spacing-96 auto 0 auto;
  padding: $spacing-64 $spacing-96;
  width: 80%;
  border: 1px solid;
  background:
    linear-gradient(90deg, #171321 0%, #171321 100%) padding-box,
    linear-gradient(90deg, #e2b6f1 0%, #a989f5 100%) border-box;
  border-radius: 4px 90px 4px 4px;
  border-image-source: linear-gradient(90deg, #e2b6f1 0%, #a989f5 100%);
  @media (max-width: $breakpoint-lg) {
    padding: $spacing-16 $spacing-32;
    width: 100%;
  }
  // Marketo form styling
  :deep(.form_column .form_container) {
    background: transparent;
    .mktoForm_container {
      @media (min-width: $breakpoint-lg) {
        display: grid;
        grid-template-columns: 1fr 1fr;
        column-gap: 30px;
        .mktoFormRow:nth-of-type(11) {
          grid-column: 1/3;
        }
        .mktoButtonRow {
          grid-column: 1/3;
        }
      }
    }
    label,
    .mktoErrorMsg {
      color: $color-surface-800;
    }
    .mktoAsterix {
      display: none;
    }
    .mktoButton {
      background: $color-accent-500 !important;
      transition: all 0.3s;
      &:hover {
        background: $color-surface-900 !important;
        color: $color-text-300;
      }
    }
  }
  &--light {
    background: $color-text-50;
    color: $color-primary-200;
    border-radius: 4px 4px 90px 4px;
    overflow: hidden;
    border: none;
    :deep {
      .slp-icon {
        color: $color-primary-200 !important;
      }
      .form_column {
        padding: 0 !important;
        margin-top: $spacing-32;
        .form_container {
          padding: 0 !important;
          border: none;
          color: $color-primary-200;
          label {
            color: $color-primary-200;
            text-transform: lowercase !important;
          }
          .mktoButton {
            background: $color-text-300 !important;
            transition: all 0.3s;
            color: $color-text-50;
            &:hover {
              background: $color-text-50 !important;
              color: $color-text-300;
            }
          }
          .mktoFormRow:nth-of-type(9) {
            grid-column: 1/3;
          }
          .mktoFieldDescriptor .mktoCheckboxList {
            width: 100%;
            label {
              text-transform: inherit !important;
            }
          }
          .required_label {
            font-size: 14px;
            font-style: italic;
          }
        }
      }
    }
  }
}
.header {
  margin-top: $spacing-32;
}
.description {
  margin-top: $spacing-24;
}
</style>
